package ru.landgrafhomyak.db.sql_skeleton_0.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.queries.RawStatement
import ru.landgrafhomyak.db.sql_skeleton_0.api.queries._Statement
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.Table
import ru.landgrafhomyak.db.sql_skeleton_0.api.runtime.InputRow
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.TableConstructor


public interface CreateModuleScope<mUE : Any, RUNTIME_KEY : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("rootNs")
	public val rootNs: Namespace<mUE, RUNTIME_KEY>

	public fun <tUE : Any> createTable(
		lifeTime: Table.LifeTime = Table.LifeTime.DATABASE_SCOPE,
		namespace: Namespace<mUE, RUNTIME_KEY> = this.rootNs,
		name: String, initializer: TableConstructor<tUE, RUNTIME_KEY>
	): Table<tUE, mUE, RUNTIME_KEY>

	public fun moduleScopedObject(namespace: Namespace<mUE, RUNTIME_KEY> = this.rootNs, name: String): ModuleScopedObject<mUE, RUNTIME_KEY>

	public fun <mUE : Any> substituteModule(rootNs: Namespace<mUE, RUNTIME_KEY>, template: ModuleTemplate<mUE>): Module<mUE, RUNTIME_KEY>

	public fun namespace(parent: Namespace<mUE, RUNTIME_KEY>, name: String): Namespace<mUE, RUNTIME_KEY>

	public fun addStatement(stmt: RawStatement.Void2Void.ImplementationsProvider<*>)
	public fun addStatement(stmt: _Statement.Void2Void<*, RUNTIME_KEY>)

	@LowLevelApi
	public fun <sUE : Any> _addStatement(stmt: RawStatement.Params2Void.ImplementationsProvider<sUE>): InputRow._Scope<sUE, Unit>

	@LowLevelApi
	public fun <sUE : Any> _addStatement(stmt: _Statement.Params2Void<sUE, RUNTIME_KEY>): InputRow._Scope<sUE, Unit>
}