package ru.landgrafhomyak.db.sql_skeleton_0.api.runtime

import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.RowId
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.Table
import ru.landgrafhomyak.db.sql_skeleton_0.api.queries._Statement

public interface Executor {
	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun _startTransaction(): Transaction

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeAutoTransactedQuery(compiledQuery: _Statement.Void2Table<QueryUserExtension>): OutputRow._Iterator<QueryUserExtension, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeAutoTransactedQuery(compiledQuery: _Statement.Params2Table<QueryUserExtension>): InputRow._Scope<QueryUserExtension, OutputRow._Iterator<QueryUserExtension, Unit>>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeAutoTransactedQuery(compiledQuery: _Statement.Table2Void<QueryUserExtension>): InputRow._Iterator<QueryUserExtension, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeAutoTransactedQuery(compiledQuery: _Statement.Params2Void<QueryUserExtension>): InputRow._Scope<QueryUserExtension, Unit>

	public fun <TableUserException : Any, V> mapOfRowIds(
		table: Table<TableUserException, *>,
		builder: (MutableMap<OutputRow<TableUserException>, V>) -> Unit
	): Map<RowId<TableUserException>, V>

	public fun <TableUserException : Any, V> mutableMapOfRowIds(table: Table<TableUserException, *>): MutableMap<RowId<TableUserException>, V>
}