package ru.landgrafhomyak.db.sql_skeleton_0.api.runtime

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.misc.QueryParam

public interface InputRow<qUE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: qUE

	public operator fun <RuntimeType> set(c: QueryParam<RuntimeType, qUE>, value: RuntimeType)

	public operator fun set(c: QueryParam<Byte, qUE>, value: Byte): Unit = this.set<Byte>(c, value)
	public operator fun set(c: QueryParam<UByte, qUE>, value: UByte): Unit = this.set<UByte>(c, value)
	public operator fun set(c: QueryParam<Short, qUE>, value: Short): Unit = this.set<Short>(c, value)
	public operator fun set(c: QueryParam<UShort, qUE>, value: UShort): Unit = this.set<UShort>(c, value)
	public operator fun set(c: QueryParam<Int, qUE>, value: Int): Unit = this.set<Int>(c, value)
	public operator fun set(c: QueryParam<UInt, qUE>, value: UInt): Unit = this.set<UInt>(c, value)
	public operator fun set(c: QueryParam<Long, qUE>, value: Long): Unit = this.set<Long>(c, value)
	public operator fun set(c: QueryParam<ULong, qUE>, value: ULong): Unit = this.set<ULong>(c, value)
	public operator fun set(c: QueryParam<Char, qUE>, value: Char): Unit = this.set<Char>(c, value)
	public operator fun set(c: QueryParam<Boolean, qUE>, value: Boolean): Unit = this.set<Boolean>(c, value)

	public interface WithRedirect<QueryUserExtension : Any, ParentQueryUserExtension : Any> : InputRow<QueryUserExtension> {
		public fun <RT> redirect(c: QueryParam<RT, QueryUserExtension>, value: QueryParam<RT, ParentQueryUserExtension>)
	}

	@Suppress("ClassName")
	@LowLevelApi
	public interface _Scope<QueryUserExtension : Any, out Next> : InputRow<QueryUserExtension> {
		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _finish(): Next

		@Suppress("FunctionName")
		@LowLevelApi
		public suspend fun _abort()
	}


	@Suppress("ClassName")
	@LowLevelApi
	public interface _Iterator<QueryUserExtension : Any, out Next> : _Scope<QueryUserExtension, Next> {
		@Suppress("FunctionName")
		@LowLevelApi
		public fun _next(): Boolean
	}
}