package ru.landgrafhomyak.db.sql_skeleton_0.api.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.DebugApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.module.Module
import ru.landgrafhomyak.db.sql_skeleton_0.api.module.Namespace

public interface Table<UE : Any, mUE : Any, RUNTIME_KEY : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: UE

	@DebugApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getName")
	public val name: String

	@DebugApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getNamespace")
	public val namespace: Namespace<mUE, RUNTIME_KEY>

	@DebugApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getModule")
	public val module: Module<mUE, RUNTIME_KEY>

	public enum class LifeTime {
		DATABASE_SCOPE,
		TRANSACTION_SCOPE,
		CONNECTION_SCOPE,
		MODULE_UPGRADE_SCOPE
	}

	@DebugApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getLifeTime")
	public val lifeTime: LifeTime
}